"use strict";Object.defineProperty(exports, "__esModule", {value: true});var _bitmax = require('./rate/bitmax');
var _coinbase = require('./rate/coinbase');
var _coincap = require('./rate/coincap');
var _coingecko = require('./rate/coingecko');
var _coinmonitor = require('./rate/coinmonitor');
var _compound = require('./rate/compound');
var _constantRate = require('./rate/constantRate');
var _currencyconverterapi = require('./rate/currencyconverterapi');
var _edgeRates = require('./rate/edgeRates');
var _nomics = require('./rate/nomics');
var _wazirx = require('./rate/wazirx');
var _changehero = require('./swap/changehero');
var _changenow = require('./swap/changenow');
var _lifi = require('./swap/defi/lifi');
var _thorchain = require('./swap/defi/thorchain');
var _thorchainDa = require('./swap/defi/thorchainDa');
var _spookySwap = require('./swap/defi/uni-v2-based/plugins/spookySwap');
var _tombSwap = require('./swap/defi/uni-v2-based/plugins/tombSwap');
var _velodrome = require('./swap/defi/uni-v2-based/plugins/velodrome');
var _xrpDex = require('./swap/defi/xrpDex');
var _exolix = require('./swap/exolix');
var _godex = require('./swap/godex');
var _letsexchange = require('./swap/letsexchange');
var _sideshift = require('./swap/sideshift');
var _swapuz = require('./swap/swapuz');
var _transfer = require('./swap/transfer');

const edgeCorePlugins = {
  // Rate plugins:
  bitmax: _bitmax.makeBitMaxPlugin,
  coinbase: _coinbase.makeCoinbasePlugin,
  coincap: _coincap.makeCoincapPlugin,
  coingecko: _coingecko.makeCoinGeckoPlugin,
  coinmonitor: _coinmonitor.makeCoinmonitorPlugin,
  compound: _compound.makeCompoundPlugin,
  constantRate: _constantRate.makeConstantRatePlugin,
  currencyconverterapi: _currencyconverterapi.makeCurrencyconverterapiPlugin,
  edgeRates: _edgeRates.makeEdgeRatesPlugin,
  nomics: _nomics.makeNomicsPlugin,
  wazirx: _wazirx.makeWazirxPlugin,

  // Swap plugins:
  changehero: _changehero.makeChangeHeroPlugin,
  changenow: _changenow.makeChangeNowPlugin,
  exolix: _exolix.makeExolixPlugin,
  godex: _godex.makeGodexPlugin,
  lifi: _lifi.makeLifiPlugin,
  sideshift: _sideshift.makeSideshiftPlugin,
  spookySwap: _spookySwap.makeSpookySwapPlugin,
  tombSwap: _tombSwap.makeTombSwapPlugin,
  swapuz: _swapuz.makeSwapuzPlugin,
  thorchain: _thorchain.makeThorchainPlugin,
  thorchainda: _thorchainDa.makeThorchainDaPlugin,
  transfer: _transfer.makeTransferPlugin,
  velodrome: _velodrome.makeVelodromePlugin,
  xrpdex: _xrpDex.makeXrpDexPlugin,
  letsexchange: _letsexchange.makeLetsExchangePlugin
}

if (
  typeof window !== 'undefined' &&
  typeof window.addEdgeCorePlugins === 'function'
) {
  window.addEdgeCorePlugins(edgeCorePlugins)
}

exports. default = edgeCorePlugins
