"use strict";Object.defineProperty(exports, "__esModule", {value: true});var _cleaners = require('cleaners');


const asCoinbaseResponse = _cleaners.asObject.call(void 0, {
  data: _cleaners.asObject.call(void 0, {
    rates: _cleaners.asMap.call(void 0, _cleaners.asString)
  })
})

 function makeCoinbasePlugin(
  opts
) {
  const { io, log } = opts
  const { fetchCors = io.fetch } = io

  return {
    rateInfo: {
      pluginId: 'coinbase',
      displayName: 'Coinbase'
    },

    async fetchRates(pairsHint) {
      const pairs = []
      try {
        const reply = await fetchCors(
          'https://api.coinbase.com/v2/exchange-rates'
        )
        const json = await reply.json()
        const cleanJson = asCoinbaseResponse(json)
        for (const pair of pairsHint) {
          const cc = pair.fromCurrency
          if (
            cleanJson.data.rates[cc] == null ||
            cleanJson.data.rates[cc] === ''
          )
            continue
          const rate = Number(cleanJson.data.rates[cc])
          pairs.push({
            fromCurrency: 'iso:USD',
            toCurrency: cc,
            rate
          })
        }
      } catch (e) {
        log.warn(`Issue with Coinbase rate data structure ${String(e)}`)
      }
      return pairs
    }
  }
} exports.makeCoinbasePlugin = makeCoinbasePlugin;
