"use strict";Object.defineProperty(exports, "__esModule", {value: true});var _cleaners = require('cleaners');


const asCToken = _cleaners.asObject.call(void 0, {
  cToken: _cleaners.asArray.call(void 0, 
    _cleaners.asObject.call(void 0, {
      exchange_rate: _cleaners.asObject.call(void 0, {
        value: _cleaners.asString
      }),
      underlying_symbol: _cleaners.asString,
      symbol: _cleaners.asString
    })
  )
})

function fixCurrency(currencyCode) {
  return currencyCode.toUpperCase()
}

 function makeCompoundPlugin(
  opts
) {
  const { io } = opts
  const { fetchCors = io.fetch } = io

  return {
    rateInfo: {
      pluginId: 'compound',
      displayName: 'Compound'
    },

    async fetchRates() {
      const reply = await fetchCors(
        'https://api.compound.finance/api/v2/ctoken'
      )
      const json = asCToken(await reply.json())

      const pairs = []
      for (const rateInfo of json.cToken) {
        const rate = Number(rateInfo.exchange_rate.value)
        const toCurrency = fixCurrency(rateInfo.underlying_symbol)
        const fromCurrency = fixCurrency(rateInfo.symbol)
        pairs.push({
          fromCurrency,
          toCurrency,
          rate
        })
      }

      return pairs
    }
  }
} exports.makeCompoundPlugin = makeCompoundPlugin;
