import { EdgeCurrencyConfig } from 'edge-core-js/types';
export interface InOutTokenAddresses {
    fromTokenAddress: string;
    toTokenAddress: string;
    isWrappingSwap: boolean;
    isFromNativeCurrency: boolean;
    isToNativeCurrency: boolean;
    isFromWrappedCurrency: boolean;
    isToWrappedCurrency: boolean;
}
/**
 * Determine if the tokens are wrapped and return the appropriate wrapped
 * contract addresses, if different.
 */
export declare const getInOutTokenAddresses: (currencyConfig: EdgeCurrencyConfig, wrappedMainnetAddress: string, fromTokenId?: string, toTokenId?: string) => InOutTokenAddresses;
export declare const getEvmApprovalData: (params: {
    contractAddress: string;
    assetAddress: string;
    nativeAmount: string;
}) => Promise<string | undefined>;
export declare const getEvmTokenData: (params: {
    memo: string;
    assetAddress: string;
    contractAddress: string;
    vaultAddress: string;
    amountToSwapWei: number;
}) => Promise<string>;
