import { EdgeCorePluginOptions, EdgeSwapPlugin } from 'edge-core-js/types';
import { InvalidCurrencyCodes } from '../../swap-helpers';
export declare const MIDGARD_SERVERS_DEFAULT: string[];
export declare const THORNODE_SERVERS_DEFAULT: string[];
export declare const EXPIRATION_MS: number;
export declare const DIVIDE_PRECISION = 16;
export declare const EXCHANGE_INFO_UPDATE_FREQ_MS = 60000;
export declare const EVM_SEND_GAS = "80000";
export declare const EVM_TOKEN_SEND_GAS = "80000";
export declare const MIN_USD_SWAP = "10";
export declare const THOR_LIMIT_UNITS = "100000000";
export declare const VOLATILITY_SPREAD_DEFAULT = 0.0075;
export declare const LIKE_KIND_VOLATILITY_SPREAD_DEFAULT = 0.005;
export declare const VOLATILITY_SPREAD_STREAMING_DEFAULT = 0.001;
export declare const LIKE_KIND_VOLATILITY_SPREAD_STREAMING_DEFAULT = 0;
export declare const PER_ASSET_SPREAD_DEFAULT: AssetSpread[];
export declare const INVALID_CURRENCY_CODES: InvalidCurrencyCodes;
export declare const EVM_CURRENCY_CODES: {
    [cc: string]: boolean;
};
export declare const MAINNET_CODE_TRANSCRIPTION: {
    [cc: string]: ChainTypes;
};
export declare const asInitOptions: import("cleaners").ObjectCleaner<{
    appId: string;
    affiliateFeeBasis: string;
    ninerealmsClientId: string;
    thorname: string;
}>;
export declare const asInboundAddresses: import("cleaners").Cleaner<{
    address: string;
    chain: string;
    outbound_fee: string;
    halted: boolean;
    pub_key: string;
    router: string | undefined;
}[]>;
export declare const asPool: import("cleaners").ObjectCleaner<{
    asset: string;
    status: string;
    assetPrice: string;
    assetPriceUSD: string;
    assetDepth: string;
    runeDepth: string;
}>;
export declare const asAssetSpread: import("cleaners").ObjectCleaner<{
    sourcePluginId: string | undefined;
    sourceTokenId: string | undefined;
    sourceCurrencyCode: string | undefined;
    destPluginId: string | undefined;
    destTokenId: string | undefined;
    destCurrencyCode: string | undefined;
    volatilitySpread: number;
}>;
export declare const asExchangeInfo: import("cleaners").ObjectCleaner<{
    swap: {
        plugins: any;
    };
}>;
declare type AssetSpread = ReturnType<typeof asAssetSpread>;
export declare function makeThorchainPlugin(opts: EdgeCorePluginOptions): EdgeSwapPlugin;
declare type ChainTypes = 'BTC' | 'ETH' | 'BCH' | 'DOGE' | 'LTC' | 'AVAX' | 'BNB' | 'THOR';
export declare const getGasLimit: (chain: ChainTypes, asset: string) => string | undefined;
export declare const getVolatilitySpread: ({ fromPluginId, fromTokenId, fromCurrencyCode, toPluginId, toTokenId, toCurrencyCode, likeKindVolatilitySpread, volatilitySpread, perAssetSpread }: {
    fromPluginId: string;
    fromTokenId?: string | undefined;
    fromCurrencyCode: string;
    toPluginId: string;
    toTokenId?: string | undefined;
    toCurrencyCode: string;
    likeKindVolatilitySpread: number;
    volatilitySpread: number;
    perAssetSpread: AssetSpread[];
}) => string;
export {};
