import { EdgeSwapInfo, EdgeSwapRequest } from 'edge-core-js';
import { Contract, ethers, PopulatedTransaction } from 'ethers';
import { InOutTokenAddresses } from '../defiUtils';
/**
 * Get the output swap amounts based on the requested input amount.
 * Call the router contract to calculate amounts and check if the swap path is
 * supported.
 */
export declare const getSwapAmounts: (router: Contract, request: EdgeSwapRequest, swapInfo: EdgeSwapInfo, path: unknown, isWrappingSwap: boolean) => Promise<{
    amountToSwap: string;
    expectedAmountOut: string;
}>;
/**
 * Get smart contract transaction(s) necessary to swap based on swap params
 */
export declare const getSwapTransactions: (provider: ethers.providers.Provider, inOutAddresses: InOutTokenAddresses, path: unknown, router: Contract, wrappedTokenContract: Contract, amountToSwap: string, expectedAmountOut: string, toAddress: string, slippage: string, deadline: number, previousGasPrice?: string) => Promise<PopulatedTransaction[]>;
