import { EdgeCurrencyWallet, EdgeFetchFunction, EdgeFetchResponse, EdgeSwapRequest } from 'edge-core-js';
import { EdgeSwapRequestPlugin } from '../swap/types';
export interface QueryParams {
    [key: string]: string | number | boolean | null;
}
export declare const promiseWithTimeout: <T>(promise: Promise<T>, timeoutMs?: number) => Promise<T>;
declare type AsyncFunction = () => Promise<any>;
export declare function snooze(ms: number): Promise<void>;
export declare const shuffleArray: <T>(array: T[]) => T[];
export declare function asyncWaterfall(asyncFuncs: AsyncFunction[], timeoutMs?: number): Promise<any>;
export declare function fetchWaterfall(fetch: EdgeFetchFunction, servers: string[], path: string, options?: any, timeout?: number): Promise<EdgeFetchResponse>;
export declare const fetchInfo: (fetch: EdgeFetchFunction, path: string, options?: Object, timeout?: number) => Promise<any>;
export declare const fetchRates: (fetch: EdgeFetchFunction, path: string, options?: Object, timeout?: number) => Promise<any>;
export declare const prettyLogObject: (val: any) => void;
export declare const makeQueryParams: (params: QueryParams) => string;
export declare const convertRequest: (request: EdgeSwapRequest) => EdgeSwapRequestPlugin;
export declare function getAddress(wallet: EdgeCurrencyWallet): Promise<string>;
export declare const hexToDecimal: (hex: string) => string;
export {};
