"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }var _cleaners = require('cleaners');

var _ethers = require('ethers');

var _THORCHAIN_SWAP_ABI = require('./abi/THORCHAIN_SWAP_ABI'); var _THORCHAIN_SWAP_ABI2 = _interopRequireDefault(_THORCHAIN_SWAP_ABI);
var _UNISWAP_V2_ERC20_ABI = require('./abi/UNISWAP_V2_ERC20_ABI'); var _UNISWAP_V2_ERC20_ABI2 = _interopRequireDefault(_UNISWAP_V2_ERC20_ABI);











const asContractLocation = _cleaners.asObject.call(void 0, {
  contractAddress: _cleaners.asString
})

/**
 * Determine if the tokens are wrapped and return the appropriate wrapped
 * contract addresses, if different.
 */
 const getInOutTokenAddresses = (
  currencyConfig,
  wrappedMainnetAddress,
  fromTokenId,
  toTokenId
) => {
  const { allTokens } = currencyConfig

  const isFromNativeCurrency = fromTokenId == null
  const isToNativeCurrency = toTokenId == null

  const fromToken = isFromNativeCurrency
    ? undefined
    : allTokens[fromTokenId]
  const toToken = isToNativeCurrency
    ? undefined
    : allTokens[toTokenId]

  const fromTokenAddress = isFromNativeCurrency
    ? wrappedMainnetAddress
    : _nullishCoalesce(_optionalChain([_cleaners.asMaybe.call(void 0, asContractLocation), 'call', _ => _(_optionalChain([fromToken, 'optionalAccess', _2 => _2.networkLocation]))
, 'optionalAccess', _3 => _3.contractAddress]), () => ( ''))
  const toTokenAddress = isToNativeCurrency
    ? wrappedMainnetAddress
    : _nullishCoalesce(_optionalChain([_cleaners.asMaybe.call(void 0, asContractLocation), 'call', _4 => _4(_optionalChain([toToken, 'optionalAccess', _5 => _5.networkLocation])), 'optionalAccess', _6 => _6.contractAddress]), () => (
      ''))

  const isFromWrappedCurrency =
    fromTokenAddress.toLowerCase() === wrappedMainnetAddress.toLowerCase()
  const isToWrappedCurrency =
    toTokenAddress.toLowerCase() === wrappedMainnetAddress.toLowerCase()

  const isWrappingSwap =
    (isFromNativeCurrency && isToWrappedCurrency) ||
    (isFromWrappedCurrency && isToNativeCurrency)

  return {
    fromTokenAddress,
    toTokenAddress,
    isWrappingSwap,
    isFromNativeCurrency,
    isToNativeCurrency,
    isFromWrappedCurrency,
    isToWrappedCurrency
  }
}; exports.getInOutTokenAddresses = getInOutTokenAddresses

const getEvmCheckSumAddress = (assetAddress) => {
  // if (assetAddress === ETHAddress) return ETHAddress
  return _ethers.ethers.utils.getAddress(assetAddress.toLowerCase())
}

 const getEvmApprovalData = async (params



) => {
  const { contractAddress, assetAddress, nativeAmount } = params
  const contract = new _ethers.ethers.Contract(
    assetAddress,
    _UNISWAP_V2_ERC20_ABI2.default,
    _ethers.ethers.providers.getDefaultProvider()
  )

  const bnNativeAmount = _ethers.ethers.BigNumber.from(nativeAmount)
  const approveTx = await contract.populateTransaction.approve(
    contractAddress,
    bnNativeAmount,
    {
      gasLimit: '500000',
      gasPrice: '20'
    }
  )
  return approveTx.data
}; exports.getEvmApprovalData = getEvmApprovalData

 const getEvmTokenData = async (params






) => {
  // const isETH = assetAddress === ETHAddress
  const {
    // usersSendingAddress,
    assetAddress,
    contractAddress,
    memo,
    vaultAddress,
    amountToSwapWei
  } = params

  // initialize contract
  const contract = new _ethers.ethers.Contract(
    contractAddress,
    _THORCHAIN_SWAP_ABI2.default,
    _ethers.ethers.providers.getDefaultProvider()
  )

  // Dummy gasPrice that we won't actually use
  const gasPrice = _ethers.ethers.BigNumber.from('50')

  // setup contract params
  const contractParams = [
    vaultAddress,
    getEvmCheckSumAddress(assetAddress),
    amountToSwapWei.toFixed(),
    memo,
    { gasPrice }
  ]

  // call the deposit method on the thorchain router.
  const tx = await contract.populateTransaction.deposit(...contractParams)
  if (tx.data == null) throw new Error('No data in tx object')
  return tx.data
}; exports.getEvmTokenData = getEvmTokenData
