"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }var _ethers = require('ethers');

var _UNISWAP_V2_ERC20_ABI = require('../abi/UNISWAP_V2_ERC20_ABI'); var _UNISWAP_V2_ERC20_ABI2 = _interopRequireDefault(_UNISWAP_V2_ERC20_ABI);
var _UNISWAP_V2_ROUTER_ABI = require('../abi/UNISWAP_V2_ROUTER_ABI'); var _UNISWAP_V2_ROUTER_ABI2 = _interopRequireDefault(_UNISWAP_V2_ROUTER_ABI);
var _WRAPPED_FTM_ABI = require('../abi/WRAPPED_FTM_ABI'); var _WRAPPED_FTM_ABI2 = _interopRequireDefault(_WRAPPED_FTM_ABI);

//
// Providers
//

// TOOD: Use FallbackProvider when it's patched https://github.com/ethers-io/ethers.js/issues/2837
 const FTM_FALLBACK_PROVIDER_URL = 'https://rpc.ftm.tools'; exports.FTM_FALLBACK_PROVIDER_URL = FTM_FALLBACK_PROVIDER_URL
 const FTM_BASE_QUIKNODE_URL =
  'https://polished-empty-cloud.fantom.quiknode.pro/'; exports.FTM_BASE_QUIKNODE_URL = FTM_BASE_QUIKNODE_URL

 const getFtmProvider = (
  quiknodeApiKey
) =>
  new _ethers.ethers.providers.JsonRpcProvider(
    quiknodeApiKey != null && quiknodeApiKey !== ''
      ? `${exports.FTM_BASE_QUIKNODE_URL}${quiknodeApiKey}`
      : exports.FTM_FALLBACK_PROVIDER_URL
  ); exports.getFtmProvider = getFtmProvider

//
// Contracts
//

// Routers
const SPOOKYSWAP_ROUTER_ADDRESS = '0xF491e7B69E4244ad4002BC14e878a34207E38c29'
 const makeSpookySwapRouterContract = (
  provider
) =>
  new _ethers.ethers.Contract(
    SPOOKYSWAP_ROUTER_ADDRESS,
    _UNISWAP_V2_ROUTER_ABI2.default,
    provider
  ); exports.makeSpookySwapRouterContract = makeSpookySwapRouterContract

const TOMBSWAP_ROUTER_ADDRESS = '0x6D0176C5ea1e44b08D3dd001b0784cE42F47a3A7'
 const makeTombSwapRouterContract = (
  provider
) =>
  new _ethers.ethers.Contract(TOMBSWAP_ROUTER_ADDRESS, _UNISWAP_V2_ROUTER_ABI2.default, provider); exports.makeTombSwapRouterContract = makeTombSwapRouterContract

// Wrapped Tokens
 const WFTM_TOKEN_ADDRESS = '0x21be370D5312f44cB42ce377BC9b8a0cEF1A4C83'; exports.WFTM_TOKEN_ADDRESS = WFTM_TOKEN_ADDRESS
 const makeWrappedFtmContract = (
  provider
) =>
  new _ethers.ethers.Contract(exports.WFTM_TOKEN_ADDRESS, _WRAPPED_FTM_ABI2.default, provider); exports.makeWrappedFtmContract = makeWrappedFtmContract

 const makeErc20Contract = (
  provider,
  tokenAddress
) => new _ethers.ethers.Contract(tokenAddress, _UNISWAP_V2_ERC20_ABI2.default, provider); exports.makeErc20Contract = makeErc20Contract
