"use strict";Object.defineProperty(exports, "__esModule", {value: true});






var _types = require('edge-core-js/types');





var _swaphelpers = require('../swap-helpers');
var _utils = require('../util/utils');


const pluginId = 'transfer'

const swapInfo = {
  pluginId,
  displayName: 'Transfer',
  orderUri: undefined,
  supportEmail: 'support@edge.com'
}

 function makeTransferPlugin(
  opts
) {
  const fetchSwapQuoteInner = async (
    request
  ) => {
    const {
      publicAddress: toAddress
    } = await request.toWallet.getReceiveAddress()

    const spendInfo = {
      currencyCode: request.fromCurrencyCode,
      spendTargets: [
        {
          nativeAmount: request.nativeAmount,
          publicAddress: toAddress
        }
      ],
      swapData: {
        isEstimate: false,
        payoutAddress: toAddress,
        plugin: { ...swapInfo },
        payoutCurrencyCode: request.toCurrencyCode,
        payoutNativeAmount: request.nativeAmount,
        payoutWalletId: request.toWallet.id
      }
    }

    return {
      request,
      spendInfo,
      swapInfo,
      fromNativeAmount: request.nativeAmount
    }
  }

  const out = {
    swapInfo,

    async fetchSwapQuote(req) {
      const request = _utils.convertRequest.call(void 0, req)
      if (
        request.fromWallet.currencyInfo.pluginId !==
          request.toWallet.currencyInfo.pluginId ||
        request.fromCurrencyCode !== request.toCurrencyCode
      ) {
        throw new (0, _types.SwapCurrencyError)(
          swapInfo,
          request.fromCurrencyCode,
          request.toCurrencyCode
        )
      }

      const newRequest = await _swaphelpers.getMaxSwappable.call(void 0, fetchSwapQuoteInner, request)
      const swapOrder = await fetchSwapQuoteInner(newRequest)
      return await _swaphelpers.makeSwapPluginQuote.call(void 0, swapOrder)
    }
  }

  return out
} exports.makeTransferPlugin = makeTransferPlugin;
