"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }var _biggystring = require('biggystring');








const INFO_SERVERS = ['https://info1.edge.app', 'https://info2.edge.app']
const RATES_SERVERS = ['https://rates1.edge.app', 'https://rates2.edge.app']





 const promiseWithTimeout = async ( 
  promise,
  timeoutMs = 5000
) => {
  return await new Promise((resolve, reject) => {
    promise.then(v => resolve(v)).catch(e => reject(e))
    setTimeout(() => reject(new Error('PROMISE_TIMEOUT')), timeoutMs)
  })
}; exports.promiseWithTimeout = promiseWithTimeout

//
// All routines below borrowed verbatim from edge-react-gui
//



 async function snooze(ms) {
  return await new Promise((resolve) => setTimeout(() => resolve(), ms))
} exports.snooze = snooze;

 const shuffleArray = (array) => {
  let currentIndex = array.length
  let temporaryValue, randomIndex

  // While there remain elements to shuffle...
  while (currentIndex !== 0) {
    // Pick a remaining element...
    randomIndex = Math.floor(Math.random() * currentIndex)
    currentIndex -= 1

    // And swap it with the current element.
    temporaryValue = array[currentIndex]
    array[currentIndex] = array[randomIndex]
    array[randomIndex] = temporaryValue
  }

  return array
}; exports.shuffleArray = shuffleArray

 async function asyncWaterfall(
  asyncFuncs,
  timeoutMs = 5000
) {
  let pending = asyncFuncs.length
  const promises = []
  for (const func of asyncFuncs) {
    const index = promises.length
    promises.push(
      func().catch(e => {
        e.index = index
        throw e
      })
    )
    if (pending > 1) {
      promises.push(
        new Promise((resolve, reject) => {
          snooze(timeoutMs)
            .then(() => {
              resolve('async_waterfall_timed_out')
            })
            .catch(e => reject(e))
        })
      )
    }
    try {
      const result = await Promise.race(promises)
      if (result === 'async_waterfall_timed_out') {
        const p = promises.pop()
        _optionalChain([p, 'optionalAccess', _ => _.then, 'call', _2 => _2(), 'access', _3 => _3.catch, 'call', _4 => _4()])
        --pending
      } else {
        return result
      }
    } catch (e) {
      const i = e.index
      promises.splice(i, 1)
      const p = promises.pop()
      _optionalChain([p, 'optionalAccess', _5 => _5.then, 'call', _6 => _6(), 'access', _7 => _7.catch, 'call', _8 => _8()])
      --pending
      if (pending === 0) {
        throw e
      }
    }
  }
} exports.asyncWaterfall = asyncWaterfall;

 async function fetchWaterfall(
  fetch,
  servers,
  path,
  options,
  timeout = 5000
) {
  const funcs = servers.map(server => async () => {
    const result = await fetch(server + '/' + path, options)
    if (typeof result !== 'object') {
      const msg = `Invalid return value ${path} in ${server}`
      throw new Error(msg)
    }
    return result
  })
  return await asyncWaterfall(funcs, timeout)
} exports.fetchWaterfall = fetchWaterfall;

async function multiFetch(
  fetch,
  servers,
  path,
  options,
  timeout = 5000
) {
  if (servers == null) return
  return await fetchWaterfall(
    fetch,
    exports.shuffleArray.call(void 0, servers),
    path,
    options,
    timeout
  )
}

 const fetchInfo = async (
  fetch,
  path,
  options,
  timeout
) => {
  return await multiFetch(fetch, INFO_SERVERS, path, options, timeout)
}; exports.fetchInfo = fetchInfo
 const fetchRates = async (
  fetch,
  path,
  options,
  timeout
) => {
  return await multiFetch(fetch, RATES_SERVERS, path, options, timeout)
}; exports.fetchRates = fetchRates

 const prettyLogObject = (val) =>
  console.log(JSON.stringify(val, null, 2)); exports.prettyLogObject = prettyLogObject

 const makeQueryParams = (params) => {
  return Object.keys(params)
    .map(key => {
      const value = params[key]
      return value == null ? key : `${key}=${encodeURIComponent(value)}`
    })
    .join('&')
}; exports.makeQueryParams = makeQueryParams

 const convertRequest = (
  request
) => {
  if (request.fromCurrencyCode == null || request.toCurrencyCode == null) {
    throw new Error('Missing request fields')
  }
  const out = request
  return out
}; exports.convertRequest = convertRequest

 async function getAddress(wallet) {
  const { publicAddress, segwitAddress } = await wallet.getReceiveAddress()
  return _nullishCoalesce(segwitAddress, () => ( publicAddress))
} exports.getAddress = getAddress;

 const hexToDecimal = (hex) => {
  if (hex.startsWith('0x')) {
    return _biggystring.add.call(void 0, hex, '0')
  } else {
    return _biggystring.add.call(void 0, `0x${hex}`, '0')
  }
}; exports.hexToDecimal = hexToDecimal
